#!/usr/bin/env python
# -*- coding: utf8 -*-

import sys, time, os, pdb
from flickrapi import FlickrAPI

APIKEY = open("/home/facundo/.flickr/api_key.txt").read().strip()
SECRET = open("/home/facundo/.flickr/sharedsecret.txt").read().strip()
NSID = "54757453@N00"

class Tiempo(object):
    def __init__(self, verbose):
        self.verbose = verbose
    def ini(self, msg):
        self.tini = time.time()
        if self.verbose:
            print "%s..." % msg,
            sys.stdout.flush()
    def fin(self, msg="Ok"):
        if self.verbose:
            print " %s  (%.1f)" % (msg, time.time()-self.tini)


def retag(imgs, tags, verbose):
    # convertimos params
    tiempo = Tiempo(verbose)

    # levantamos toda la info de auth
    tiempo.ini("Autenticando")
    fapi = FlickrAPI(APIKEY, SECRET)

    token = fapi.getToken(perms="write")
    tiempo.fin()

    # tageamos
    totalimgs = len(imgs)
    for num,nomimg in enumerate(imgs):
        # averiguamos la info de la foto
        tiempo.ini("Buscando la foto %s" % nomimg)
        rsp = fapi.photos_search(api_key=APIKEY, user_id="me", auth_token=token, text=nomimg)
        fapi.testFailure(rsp)
        encontradas = rsp.photos[0]
        cant = int(encontradas["total"])
        if cant != 1:
            print "*** Warning! Encontramos %d fotos!!" % cant
        tiempo.fin()

        # tageamos la foto
        for foto in encontradas.photo:
            tiempo.ini("Tagueando id %s (%d/%d)" % (foto["id"], num+1, totalimgs))
            rsp = fapi.photos_addTags(api_key=APIKEY, auth_token=token, photo_id=foto["id"], tags=tags)
            fapi.testFailure(rsp)
            tiempo.fin()

    return


if __name__ == "__main__":
    from optparse import OptionParser
    parser = OptionParser(usage="%prog [options] imag1 [imag2 [...]]")
    parser.add_option("-q", "--quiet", action="store_false", dest="verbose", default=True, help="no tira mensajes de lo que va pasando ([False])")
    parser.add_option("-t", "--tags", dest="tags", default="", help="lista de palabras nuevas")
    (opts, args) = parser.parse_args()

    if not opts.tags:
        print parser.format_help()
        sys.exit()

    if not args:
        print parser.format_help()
        sys.exit()

    tags = opts.tags.decode("utf8")
    retag(args, tags, opts.verbose)
